#define _WIN32_WINNT 0x0400
#include <windows.h>


//Low level keyboard hook and proc
HHOOK hhkLowLevelKybd;
LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode == HC_ACTION && (wParam==WM_KEYDOWN || wParam==WM_SYSKEYDOWN)) //If a key is pressed...
	{
		DWORD MyCode=((PKBDLLHOOKSTRUCT)lParam)->vkCode; //Get virtual key code
		static int LastKey=0; //Remember last pressed key
		if(LastKey==13 && MyCode==13) //If last 2 pressed keys were enter, exit
			PostQuitMessage(0);
		printf("%02X   %d\n", MyCode, MyCode); //Output hex then decimal of the pressed key
		LastKey=MyCode;
	}

	return(CallNextHookEx(hhkLowLevelKybd, nCode, wParam, lParam)); //Continue with next keyboard hook
}

void main()
{
	MSG msg; //Windows message structure
	printf("Press enter consecutively to exit.\n\nHEX  DECIMAL\n"); //Inform the user of the output format
	hhkLowLevelKybd  = SetWindowsHookEx(WH_KEYBOARD_LL, LowLevelKeyboardProc, GetModuleHandle(NULL), 0); //Hook the keyboard
	while(GetMessage(&msg,  NULL, 0, 0)); //Wait until process is ready to exit
	UnhookWindowsHookEx(hhkLowLevelKybd); //Unhook the keyboard
}